> ## Documentation Index
> Fetch the complete documentation index at: https://docs.rated.network/llms.txt
> Use this file to discover all available pages before exploring further.

# Validator Checkpoint Effectiveness

This endpoint returns all the useful information you will ever need on the historical performance of a single validator. This includes rewards (checkpoint signings, proposals, Bor proposals), performance (effectiveness and its components), stake distribution, and so much more. For a glossary of the variables returned, see [effectiveness](/rated-api/glossary/polygon/validators).

Here's how to interpret the inputs required to operate it:

| Parameter   | Context                                                                        |
| :---------- | :----------------------------------------------------------------------------- |
| from        | Starting checkpoint (integer, e.g. 52922) or UTC date (e.g. from="2023-10-31") |
| granularity | The size of time increments you are looking to query. Can be checkpoint or day |
| size        | The number of results included per page                                        |


## OpenAPI

````yaml get /v0/polygon/validators/{validator_id}/effectiveness
openapi: 3.1.0
info:
  title: Rated API
  description: >

    Welcome to Rated API Swagger doc for developers! This doc outlines the Rated
    API functionality and API architecture.


    V0: It is separated into seven categories:


    -   **Validators**: Endpoints to query into individual validator indices or
    aggregations of validator indices.

    -   **Operators**: Endpoints to query into pre-materialized operator
    groupings.

    -   **Network**: Endpoints to query into network aggregate stats.

    -   **Slashings**: Endpoints to query into network aggregate stats.

    -   **Withdrawals (beta)**: Endpoints to query into when a withdrawal is
    expected to land.

    -   **Self Report (beta)**: Endpoint to query into all slashed validators
    and individual slashed validator indices


    V1: It is separated into six categories:

    -   **Overview**: Endpoints encapsulating the current status of operators,
    pools and validators.

    -   **Performance**: Endpoints that dive into performance and effectiveness
    metrics on execution and consensus layer for operators, pools and
    validators.

    -   **Rewards**: Endpoints that dive into relevant metrics around rewards
    and penalties for operators, pools and validators.

    -   **Private Sets**: Endpoints that aggregate custom group of validators
    privately for performance and reward drill downs.

    -   **Metadata**: Endpoints that provide metadata about mappings, slashings
    and APRs for validators, pools and operators.

    -   **Network**: Endpoints that provide network level metrics about
    performance, rewards, and distributions.


    [Terms of Use](https://docs.rated.network/legal/terms/api-terms-of-service)


    [API
    Reference](https://docs.rated.network/rated-api/api-reference/introduction)
  version: '1.0'
servers: []
security: []
paths:
  /v0/polygon/validators/{validator_id}/effectiveness:
    get:
      tags:
        - Polygon Validators
      summary: Validator Checkpoint Effectiveness
      operationId: >-
        validator_checkpoint_effectiveness_v0_polygon_validators__validator_id__effectiveness_get
      parameters:
        - name: validator_id
          in: path
          required: true
          schema:
            type: integer
            minimum: 0
            title: Validator Id
        - name: from
          in: query
          required: false
          schema:
            anyOf:
              - {}
              - type: 'null'
            description: >-
              The starting checkpoint or date (UTC) to return. For example,
              41100 or 2021-01-01.
            title: From
          description: >-
            The starting checkpoint or date (UTC) to return. For example, 41100
            or 2021-01-01.
        - name: granularity
          in: query
          required: false
          schema:
            anyOf:
              - $ref: >-
                  #/components/schemas/networks__polygon__granularity__Granularity
              - type: 'null'
            description: Checkpoint or UTC day
            title: Granularity
          description: Checkpoint or UTC day
        - name: size
          in: query
          required: false
          schema:
            type: integer
            default: 15
            title: Size
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PaginatedResponse_PolygonValidatorStats_'
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Bad Request
      security:
        - HTTPBearer: []
components:
  schemas:
    networks__polygon__granularity__Granularity:
      type: string
      enum:
        - checkpoint
        - day
      title: Granularity
    PaginatedResponse_PolygonValidatorStats_:
      properties:
        page:
          $ref: '#/components/schemas/api__schemas__page_polygon__Page'
        total:
          type: integer
          minimum: 0
          title: Total
        data:
          items:
            $ref: '#/components/schemas/PolygonValidatorStats'
          type: array
          title: Data
        next:
          anyOf:
            - type: string
            - type: 'null'
          title: Next
      type: object
      required:
        - page
        - total
        - data
      title: PaginatedResponse[PolygonValidatorStats]
    ErrorResponse:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/Error'
          type: array
          title: Detail
      type: object
      required:
        - detail
      title: ErrorResponse
    api__schemas__page_polygon__Page:
      properties:
        from:
          anyOf:
            - type: integer
            - type: string
              format: date
            - type: 'null'
          title: From
        to:
          anyOf:
            - type: integer
            - type: string
              format: date
            - type: 'null'
          title: To
        granularity:
          anyOf:
            - $ref: '#/components/schemas/networks__polygon__granularity__Granularity'
            - type: 'null'
        size:
          anyOf:
            - type: integer
              exclusiveMinimum: 0
            - type: 'null'
          title: Size
      type: object
      title: Page
    PolygonValidatorStats:
      properties:
        validatorId:
          type: integer
          minimum: 0
          title: Validatorid
        granularity:
          $ref: '#/components/schemas/networks__polygon__granularity__Granularity'
        fromCheckpoint:
          type: integer
          minimum: 0
          title: Fromcheckpoint
        toCheckpoint:
          type: integer
          minimum: 0
          title: Tocheckpoint
        fromDate:
          anyOf:
            - type: string
              format: date
            - type: 'null'
          title: Fromdate
        toDate:
          anyOf:
            - type: string
              format: date
            - type: 'null'
          title: Todate
        checkpointSignatureDuties:
          type: integer
          minimum: 0
          title: Checkpointsignatureduties
        checkpointSignatures:
          type: integer
          minimum: 0
          title: Checkpointsignatures
        checkpointProposalDuties:
          type: integer
          minimum: 0
          title: Checkpointproposalduties
        checkpointProposals:
          type: integer
          minimum: 0
          title: Checkpointproposals
        borProposalDuties:
          type: integer
          minimum: 0
          title: Borproposalduties
        borProposals:
          type: integer
          minimum: 0
          title: Borproposals
        checkpointSignatureRewards:
          type: string
          title: Checkpointsignaturerewards
        selfSigningRewards:
          type: string
          title: Selfsigningrewards
        distributedRewards:
          type: string
          title: Distributedrewards
        commissionRewards:
          type: string
          title: Commissionrewards
        delegatorRewards:
          type: string
          title: Delegatorrewards
        missedCheckpointSignatureRewards:
          type: string
          title: Missedcheckpointsignaturerewards
        missedSelfSigningRewards:
          type: string
          title: Missedselfsigningrewards
        missedDistributedRewards:
          type: string
          title: Misseddistributedrewards
        missedCommissionRewards:
          type: string
          title: Missedcommissionrewards
        missedDelegatorRewards:
          type: string
          title: Misseddelegatorrewards
        checkpointProposalRewards:
          anyOf:
            - type: string
            - type: 'null'
          title: Checkpointproposalrewards
        missedCheckpointProposalRewards:
          anyOf:
            - type: string
            - type: 'null'
          title: Missedcheckpointproposalrewards
        priorityFees:
          type: number
          minimum: 0
          title: Priorityfees
        mevRewards:
          type: number
          minimum: 0
          title: Mevrewards
        totalStake:
          type: string
          title: Totalstake
        selfStake:
          type: string
          title: Selfstake
        delegatedStake:
          type: string
          title: Delegatedstake
        commissionRate:
          type: string
          title: Commissionrate
        delegatorCount:
          type: integer
          minimum: 0
          title: Delegatorcount
        borProposerEffectiveness:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Borproposereffectiveness
          readOnly: true
        checkpointSignatureEffectiveness:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Checkpointsignatureeffectiveness
          readOnly: true
        checkpointProposerEffectiveness:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Checkpointproposereffectiveness
          readOnly: true
        effectiveness:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Effectiveness
          readOnly: true
      type: object
      required:
        - validatorId
        - granularity
        - fromCheckpoint
        - toCheckpoint
        - checkpointSignatureDuties
        - checkpointSignatures
        - checkpointProposalDuties
        - checkpointProposals
        - borProposalDuties
        - borProposals
        - checkpointSignatureRewards
        - selfSigningRewards
        - distributedRewards
        - commissionRewards
        - delegatorRewards
        - missedCheckpointSignatureRewards
        - missedSelfSigningRewards
        - missedDistributedRewards
        - missedCommissionRewards
        - missedDelegatorRewards
        - priorityFees
        - mevRewards
        - totalStake
        - selfStake
        - delegatedStake
        - commissionRate
        - delegatorCount
        - borProposerEffectiveness
        - checkpointSignatureEffectiveness
        - checkpointProposerEffectiveness
        - effectiveness
      title: PolygonValidatorStats
      examples:
        - borProposalDuties: 10
          borProposals: 10
          borProposerEffectiveness: 100
          checkpointProposalDuties: 0
          checkpointProposalRewards: 0
          checkpointProposals: 0
          checkpointProposerEffectiveness: 0
          checkpointSignatureDuties: 0
          checkpointSignatureEffectiveness: 0
          checkpointSignatureRewards: 123.123
          checkpointSignatures: 0
          commissionRate: 0
          commissionRewards: 0
          delegatedStake: 920
          delegatorCount: 10
          delegatorRewards: 20
          distributedRewards: 20
          effectiveness: 100
          fromCheckpoint: 53105
          fromDate: '2021-09-01'
          granularity: checkpoint
          mevRewards: 0
          missedCheckpointProposalRewards: 0
          missedCheckpointSignatureRewards: 0
          missedCommissionRewards: 0
          missedDelegatorRewards: 0
          missedDistributedRewards: 0
          missedSelfSigningRewards: 0
          priorityFees: 0
          selfSigningRewards: 103.123
          selfStake: 80
          toCheckpoint: 53105
          toDate: '2021-09-01'
          totalStake: 1000
          validatorId: 103
    Error:
      properties:
        loc:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Loc
        msg:
          type: string
          title: Msg
        type:
          type: string
          title: Type
      type: object
      required:
        - msg
        - type
      title: Error
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````